///File : nbConvert.hpp
//------------------------------------------------------------------------------
/*
    This file is part of DevisMaker.

    DevisMaker is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DevisMaker is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DevisMaker.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include <string>
#include <iostream>
//------------------------------------------------------------------------------
#if not defined NB_STR_CONVERT_HPP
#define NB_STR_CONVERT_HPP
//------------------------------------------------------------------------------
template < typename T >
std::string nbToString(const T &nb)
{
    std::stringstream ss;
    std::string str;
    ss << std::fixed << nb; // fixed : pas de nb scientifique. Par contre, plein de zero...
    ss >> str;

    // On enléve les 0 et . innutils
    std::string::iterator it = str.end() - 1;
    if(str.find('.') != std::string::npos) // On ne racourci pas le nb si pas de virgule
    {
        while(str.size() > 1 && *it == '0')
        {
            str.erase(it);
            it = str.end() - 1;
        }

        if(*it == '.') // Si on arrive à la virgule ==> suppression.
        {
            str.erase(it);
        }
    }

    return str;
}

//------------------------------------------------------------------------------
template < typename T >
T stringToNb(std::string nbStr)
{
    std::stringstream ss;
    T nb;
    ss << nbStr;
    ss >> nb;
    return nb;
}
//------------------------------------------------------------------------------
#endif // NB_STR_CONVERT_HPP
